#ifndef SPIN_DRAWAREA_H_
#define SPIN_DRAWAREA_H_

#include<gtkmm.h>
#include<iostream>
#include"drawimage.h"
#include"filelist.h"

class DrawArea : public Gtk::DrawingArea{
 private:
  double *imagePX;
  double *imagePY;
  double *imageRotate;
  double *imageSize;
  int state;
  int tButton;
  double tPX;
  double tPY;
  double dPX;
  double dPY;
  double tRotate;
  Gtk::Window *parWin;
  Cairo::RefPtr<Cairo::Context> drawContext;
  FileList fileList;
  DrawImage drawImage;
  int fullFlag;
 public:
  DrawArea();
  ~DrawArea();
  void Create(Gtk::Window *window0,std::string filename0,
	      double *imagePX0,double *imagePY0,
	      double *imageRotate0,double *imageSize0);
  void SetImageVariable(std::string filename0);
  void SetImageFixed(std::string filename0);
  void OpenImage(std::string filename0);
  void NextImage();
  void PrevImage();
  void FitImage();
  std::string GetCurrentFolder();
  //signal
  typedef sigc::signal<void,double> type_rotate;
  typedef sigc::signal<void,double> type_size;
  typedef sigc::signal<void,bool> type_fullscreen;
  typedef sigc::signal<void,FileItem*,double,double> type_image;
  type_rotate SignalRotateChange(double value=0);
  type_size SignalSizeChange(double value=0);
  type_fullscreen SignalFullChange(bool value=0);
  type_image SignalImageChange
    (FileItem *target=NULL,double width=0,double height=0);
 protected:
  type_rotate rotateChange;
  type_size sizeChange;
  type_fullscreen fullChange;
  type_image imageChange;
  bool on_button_press_event(GdkEventButton *event);
  bool on_button_release_event(GdkEventButton *event);
  bool on_motion_notify_event(GdkEventMotion *event);
  bool on_scroll_event(GdkEventScroll *event);
  virtual void on_realize();
  virtual void on_size_allocate(Gdk::Rectangle &rect);
  virtual bool on_expose_event(GdkEventExpose *event);
  virtual bool on_key_press_event(GdkEventKey *event);
  virtual bool on_key_release_event(GdkEventKey *event);
  /*
  virtual void on_grab_focus();
  virtual bool on_focus_in_event(GdkEventFocus *event);
  virtual bool on_focus_out_event(GdkEventFocus *event);
  */
};

#endif
