#include "drawimage.h"

DrawImage::DrawImage(){
  imageType=0;
  imageWidth=0;
  imageHeight=0;
  pngImage.clear();
  pdfImage.clear();
  svgImage.clear();
  gdkImage.clear();
}

DrawImage::~DrawImage(){
  
}

void DrawImage::Create(){
  
}

int DrawImage::SetPng(std::string filename0){
  int flag0;
  std::cout<<"SET PNG"<<std::endl;
  try{
    pngImage=Cairo::ImageSurface::create_from_png(filename0);
    flag0=1;
    imageWidth=pngImage->get_width();
    imageHeight=pngImage->get_height();
  }
  catch(...){
    pngImage.clear();
    imageType=FILE_TYPE_NO;
    imageWidth=0;
    imageHeight=0;
    flag0=0;
  }
  return flag0;
}
int DrawImage::SetPdf(std::string filename0){
  int flag0;
  std::cout<<"SET PDF"<<std::endl;
  try{
    pdfImage=Cairo::PdfSurface::create(filename0,400,400);
    imageWidth=400;
    imageHeight=400;
    flag0=1;
  }
  catch(...){
    std::cout<<"NO PDF"<<std::endl;
    pdfImage.clear();
    imageType=FILE_TYPE_NO;
    imageWidth=0;
    imageHeight=0;
    flag0=0;
  }
  return flag0;
}
int DrawImage::SetGdk(std::string filename0){
  int flag0;
  try{
    gdkImage=Gdk::Pixbuf::create_from_file
      (Glib::locale_to_utf8(filename0));
    imageWidth=(double)gdkImage->get_width();
    imageHeight=(double)gdkImage->get_height();
    flag0=1;
  }
  catch(...){
    std::cout<<"NO GDK"<<std::endl;
    gdkImage.clear();
    imageType=FILE_TYPE_NO;
    imageWidth=0;
    imageHeight=0;
    flag0=0;
  }
  return flag0;
}
int (DrawImage::*DrawImage::DRAWIMAGE_SETIMAGE_SELECT[FILE_TYPE_NUM])
(std::string filename0)={
    &DrawImage::SetPng,
    &DrawImage::SetPdf,
    &DrawImage::SetPng,
    &DrawImage::SetGdk,
    &DrawImage::SetGdk,
    &DrawImage::SetGdk
};

int DrawImage::SetImage(std::string filename0,int type0){
  int flag0;
  std::cout<<"SET IMAGE:"<<type0<<std::endl;
  DeleteImage();
  if(type0>=0){
    imageType=type0;
    flag0=(this->*DRAWIMAGE_SETIMAGE_SELECT[type0])(filename0);
  }
  else{
    flag0=0;
  }

  return flag0;
}

void DrawImage::DrawPng(Cairo::RefPtr<Cairo::Context> context0){
  if(pngImage){
    context0->set_source(pngImage,
			(double)pngImage->get_width()/-2,
			(double)pngImage->get_height()/-2);
    context0->show_page();
    context0->paint();

  }
  else{
    imageType=FILE_TYPE_NO;
  }
}
void DrawImage::DrawPdf(Cairo::RefPtr<Cairo::Context> context0){
  if(pdfImage){
    std::cout<<"DRAW PDF"<<std::endl;
    context0->set_source(pdfImage,0,0);
    context0->show_page();
    context0->paint();
    
  }
  else{
    imageType=FILE_TYPE_NO;
  }
}
void DrawImage::DrawGdk(Cairo::RefPtr<Cairo::Context> context0){
  if(gdkImage){
    Gdk::Cairo::set_source_pixbuf(context0,gdkImage,
				  (double)gdkImage->get_width()/-2,
				  (double)gdkImage->get_height()/-2);
    context0->show_page();
    context0->paint();
  }
  else{
    imageType=FILE_TYPE_NO;
  }
}
void (DrawImage::*DrawImage::DRAWIMAGE_DRAWCONTEXT_SELECT[FILE_TYPE_NUM])
(Cairo::RefPtr<Cairo::Context> context0)={
  &DrawImage::DrawPng,
  &DrawImage::DrawPdf,
  &DrawImage::DrawPng,
  &DrawImage::DrawGdk,
  &DrawImage::DrawGdk,
  &DrawImage::DrawGdk
};

void DrawImage::DrawContext(Cairo::RefPtr<Cairo::Context> context0){
  if(imageType>=0){
    (this->*DRAWIMAGE_DRAWCONTEXT_SELECT[imageType])(context0);
  }
}

void DrawImage::DeletePng(){
  pngImage.clear();
}
void DrawImage::DeletePdf(){
  pdfImage.clear();
}
void DrawImage::DeleteGdk(){
  gdkImage.clear();
}
void (DrawImage::*DrawImage::
      DRAWIMAGE_DELETEIMAGE_SELECT[FILE_TYPE_NUM])()={
  &DrawImage::DeletePng,
  &DrawImage::DeletePdf,
  &DrawImage::DeletePng,
  &DrawImage::DeleteGdk,
  &DrawImage::DeleteGdk,
  &DrawImage::DeleteGdk
};

void DrawImage::DeleteImage(){
  if(imageType>=0){
    (this->*DRAWIMAGE_DELETEIMAGE_SELECT[imageType])();
  }
  imageWidth=0;
  imageHeight=0;
}

double DrawImage::GetWidth(){
  return imageWidth;
}

double DrawImage::GetHeight(){
  return imageHeight;
}
