#ifndef SPIN_DRAW_IMAGE_H_
#define SPIN_DRAW_IMAGE_H_

#include <gtkmm.h>
#include <iostream>
#include "filelist.h"

class DrawImage{
 private:
  int imageType;
  double imageWidth;
  double imageHeight;
  Glib::RefPtr<Gdk::Pixbuf> gdkImage;
  Cairo::RefPtr<Cairo::ImageSurface> pngImage;
  Cairo::RefPtr<Cairo::PdfSurface> pdfImage;
  Cairo::RefPtr<Cairo::SvgSurface> svgImage;
 public:
  DrawImage();
  ~DrawImage();
  void Create();
  int SetPng(std::string filename0);
  int SetPdf(std::string filename0);
  int SetGdk(std::string filename0);
  static int(DrawImage::*DRAWIMAGE_SETIMAGE_SELECT[FILE_TYPE_NUM])
    (std::string filename0);
  int SetImage(std::string filename0,int type0);

  void DrawPng(Cairo::RefPtr<Cairo::Context> context0);
  void DrawPdf(Cairo::RefPtr<Cairo::Context> context0);
  void DrawGdk(Cairo::RefPtr<Cairo::Context> context0);
  static void(DrawImage::*DRAWIMAGE_DRAWCONTEXT_SELECT[FILE_TYPE_NUM])
    (Cairo::RefPtr<Cairo::Context> context0);
  void DrawContext(Cairo::RefPtr<Cairo::Context> context0);

  void DeletePng();
  void DeletePdf();
  void DeleteGdk();
  static void(DrawImage::*DRAWIMAGE_DELETEIMAGE_SELECT[FILE_TYPE_NUM])();
  void DeleteImage();

  double GetWidth();
  double GetHeight();
};

#endif
