#include "filelist.h"
#include <dirent.h>
#include <sys/stat.h>

FileList::FileList(){
  first=NULL;
  end=NULL;
  target=NULL;
  listSize=0;
  currentFolder="./";
}

FileList::~FileList(){
  ALLDelete();
}

void FileList::Create(){
  
}

int FileList::DivLastString(std::string path0,std::string str0,int index0){
  int index;
  std::cout<<path0.substr(index0,path0.size())<<std::endl;
  index=path0.find(str0,index0);
  if(index!=std::string::npos){
    index0=DivLastString(path0,str0,index+1);
  }
  else{
    
  }
  return index0;
}

std::string FileList::GetLastString(std::string path0,std::string str0){
  std::string name0;
  int index0=0;

  index0=DivLastString(path0,str0,0);
  


  if(index0){
    name0=path0.substr(index0,path0.size()-index0);    
  }
  else{
    name0="";
  }

  return name0;
}

int FileList::TypeDistinction(std::string name0){
  int type0,index0;
  std::string extension;

  extension=GetLastString(name0,".");

  if(extension=="png"){
    type0=FILE_TYPE_PNG;
  }
  else if(extension=="pdf"){
    type0=FILE_TYPE_PDF;
  }
  else if(extension=="svg"){
    type0=FILE_TYPE_SVG;
  }
  else if(extension=="bmp"){
    type0=FILE_TYPE_BMP;
  }
  else if(extension=="jpeg"){
    type0=FILE_TYPE_JPG;
  }
  else if(extension=="jpg"){
    type0=FILE_TYPE_JPG;
  }
  else if(extension=="xpm"){
    type0=FILE_TYPE_XPM;
  }
  else{
    type0=-1;
  }

  return type0;
}

int FileList::AllowType(int type0,int *ARRAY,int length){
  int flag0,i;
  flag0=0;

  i=0;
  while(i<length){
    if(*(ARRAY+i)==type0){
      flag0=1;
    }
    i++;
  }
  
  return flag0;
}

void FileList::Append(FileItem *node){
  if(end==NULL){
    first=node;
    end=node;
    node->next=NULL;
    node->prev=NULL;
  }
  else{
    if(end->next==NULL){
      end->next=node;
      node->prev=end;
      node->next=NULL;
      end=node;
    }
    else{
      
    }
  }
  listSize++;
}

void FileList::Prepend(FileItem *node){
  if(first==NULL){
    first=node;
    end=node;
    node->prev=NULL;
    node->next=NULL;
  }
  else{
    node->next=first;
    node->prev=NULL;
    first->prev=node;
    first=node;
  }
  listSize++;
}

void FileList::Insert(FileItem *node,FileItem *target){
  if(target->prev==NULL){
    node->next=target;
    node->prev=NULL;
    target->prev=node;
    first=node;
  }
  else{
    node->next=target;
    node->prev=target->prev;
    (target->prev)->next=node;
    target->prev=node;
  }
  listSize++;
}

void FileList::Reject(FileItem *node){
  if(node->next==NULL){
    if(node->prev==NULL){
      first=NULL;
      end=NULL;
    }
    else{
      (node->prev)->next=NULL;
      end=node->prev;
    }
  }
  else{
    if(node->prev==NULL){
      (node->next)->prev=NULL;
      first=node->next;
    }
    else{
      (node->next)->prev=node->prev;
      (node->prev)->next=node->next;
    }
  }
  node->next=NULL;
  node->prev=NULL;

  listSize--;
}

void FileList::ALLDelete(){
  FileItem *node;
  FileItem *tmp;

  node=first;
  while(node){
    tmp=node->next;
    Reject(node);
    delete node;
    node=tmp;
  }
  if(listSize==0){
    std::cout<<"FILEITEM ALL DELETE!"<<std::endl;  
  }
  else{
    std::cout<<"FILEITEM DELETE ERROR"<<std::endl;
  }
}

void FileList::View(){
  FileItem *node;
  FileItem *tmp;
  int i;

  i=0;
  node=first;
  while(node){
    tmp=node->next;
    std::cout<<"["<<i<<"]"<<"\t";
    std::cout<<"NAME:"<<node->name<<"\t";
    std::cout<<"TYPE:"<<node->type<<"\t";
    std::cout<<"SIZE:"<<node->size<<"\t";
    std::cout<<"ATIME:"<<node->atime<<"\t";
    std::cout<<"MTIME:"<<node->mtime<<"\t";
    std::cout<<"CTIME:"<<node->ctime<<std::endl;
    
    i++;
    node=tmp;
  }
}

FileItem *FileList::EnterItem
(std::string name0,int type0,long long int size0,
 int atime0,int mtime0,int ctime0){
  FileItem *node;
  
  node= new FileItem();

  node->name=name0;
  node->size=size0;
  node->type=type0;
  node->atime=atime0;
  node->mtime=mtime0;
  node->ctime=ctime0;

  Append(node);

  return node;
}

void FileList::ReadFolder(std::string path0){
  FileItem *node;
  std::string filename0;
  std::string filefolder0;
  std::string name0;
  std::string filepath0;
  int type0,i;
  int allowType[10];
  DIR *dir;
  struct dirent *dp;
  struct stat STAT;

  allowType[0]=FILE_TYPE_PNG;
  allowType[1]=FILE_TYPE_JPG;
  allowType[2]=FILE_TYPE_BMP;
  allowType[3]=FILE_TYPE_XPM;
  
  ALLDelete();

  filename0=GetLastString(path0,"/");
  
  currentFolder=path0;
  currentFolder=currentFolder.erase
    (path0.find(filename0,0),filename0.size());
  
  std::cout<<"CURRENT FOLDER="<<currentFolder<<"\t"
	   <<"PATH="<<path0<<std::endl;

  if(currentFolder.size()){
    dir=opendir(currentFolder.c_str());
    i=0;
    while(dp=readdir(dir)){
      name0=dp->d_name;
      filepath0=currentFolder+name0;
      type0=TypeDistinction(filepath0);
      if(AllowType(type0,&allowType[0],4)){
	stat(filepath0.c_str(),&STAT);
	/*
	std::cout<<"["<<i<<"]"<<" ";
	std::cout<<"NAME:"<<filename0<<" ";
	std::cout<<"TYPE:"<<type0<<" ";
	std::cout<<"SIZE:"<<STAT.st_size<<std::endl;
	*/
	node=EnterItem(name0,type0,STAT.st_size,
		       STAT.st_atime,STAT.st_mtime,STAT.st_ctime);
	
	if(filename0==name0){
	  target=node;
	}
	i++;
      }
    }
    closedir(dir);
  }
  else{

  }
}

FileItem *FileList::NextTarget(){
  if(target){
    if(target->next!=NULL){
      target=target->next;
    }
    else{
      target=first;
    }
  }
  return target;
}

FileItem *FileList::PrevTarget(){
  if(target){
    if(target->prev!=NULL){
      target=target->prev;
    }
    else{
      target=end;
    }
  }
  return target;
}

FileItem *FileList::GetTarget(){
  if(target!=NULL){
    
  }
  else{
    target=first;
  }
  return target;
}

std::string FileList::GetTargetPath(){
  std::string path0;
  if(target!=NULL){
    path0=currentFolder+target->name;
  }
  else{
    path0="";
  }

  return path0;
}
int FileList::GetTargetType(){
  int type0;
  if(target!=NULL){
    type0=target->type;
  }
  else{
    type0=FILE_TYPE_NO;
  }
  return type0;
}
std::string FileList::GetCurrentFolder(){
  return currentFolder;
}
