#ifndef SPIN_FILELIST_H_
#define SPIN_FILELIST_H_

#include <iostream>

#define FILE_TYPE_NO -1
#define FILE_TYPE_PNG 0
#define FILE_TYPE_PDF 1
#define FILE_TYPE_SVG 2
#define FILE_TYPE_BMP 3
#define FILE_TYPE_JPG 4
#define FILE_TYPE_XPM 5
#define FILE_TYPE_NUM 6

class FileItem{
 public:
  std::string name;
  int type;
  long long int size;
  int atime;
  int mtime;
  int ctime;
  FileItem *next;
  FileItem *prev;
};

class FileList{
 private:
  std::string currentFolder;
  FileItem *target;
  FileItem *first;
  FileItem *end;
  int listSize;
 public:
  FileList();
  ~FileList();
  void Create();
  int DivLastString(std::string path0,std::string str0,int index0);
  std::string GetLastString(std::string path0,std::string str0);
  int TypeDistinction(std::string name0);
  int AllowType(int type0,int *ARRAY,int length);
  void Append(FileItem *node);
  void Prepend(FileItem *node);
  void Insert(FileItem *node,FileItem *target);
  void Reject(FileItem *node);
  void ALLDelete();
  void View();
  FileItem *EnterItem(std::string name0,int type0,long long int size0,
		 int atime0,int mtime0,int ctime0);
  void ReadFolder(std::string path0);
  FileItem *NextTarget();
  FileItem *PrevTarget();
  FileItem *GetTarget();
  std::string GetTargetPath();
  int GetTargetType();
  std::string GetCurrentFolder();
};

#endif
