#include "menubar.h"

SpinMenu::SpinMenu(){
  
  fileMenu.items().push_back
    (Gtk::Menu_Helpers::MenuElem
     ("Open",Gtk::AccelKey('o',Gdk::CONTROL_MASK),
      sigc::mem_fun(*this,&SpinMenu::OpenActivate)));
  fileMenu.items().push_back
    (Gtk::Menu_Helpers::MenuElem
     ("Quit",Gtk::AccelKey('q',Gdk::CONTROL_MASK),
      sigc::mem_fun(*this,&SpinMenu::ExitActivate)));

  items().push_back(Gtk::Menu_Helpers::MenuElem("File",fileMenu));
  //  items().push_back(Gtk::Menu_Helpers::MenuElem("Help",helpMenu));
}

SpinMenu::~SpinMenu(){
  
}

void SpinMenu::Create(DrawArea *drawArea0){
  drawArea=drawArea0;
  //  fileList=fileList0;
}

void SpinMenu::OpenActivate(){
  int value;
  Gtk::FileChooserDialog diag("IMAGE OPEN",Gtk::FILE_CHOOSER_ACTION_OPEN);
  Gtk::FileFilter filter;

  filter.add_pattern("*.png");
  filter.add_pattern("*.jpg");
  filter.add_pattern("*.bmp");
  filter.add_pattern("*.xpm");
  filter.set_name("image");

  diag.add_button(Gtk::Stock::OK,Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL,Gtk::RESPONSE_CANCEL);
  diag.add_filter(filter);

  diag.set_current_folder
    (Glib::locale_to_utf8(drawArea->GetCurrentFolder()));
  
  for(;;){
    value=diag.run();
    std::cout<<"VALUE="<<value<<std::endl;
    if(value==Gtk::RESPONSE_OK){
      std::cout<<"OK:"<<diag.get_filename()<<std::endl;
      drawArea->OpenImage(Glib::locale_from_utf8(diag.get_filename()));
      break;
    }
    else if(value==Gtk::RESPONSE_CANCEL){
      std::cout<<"CANCEL"<<std::endl;
      break;
    }
    else if(value==Gtk::RESPONSE_CLOSE){
      std::cout<<"CLOSE"<<std::endl;
      break;
    }
    else if(value==Gtk::RESPONSE_DELETE_EVENT){
      std::cout<<"DELETE EVENT"<<std::endl;
      break;
    }
  }
}

void SpinMenu::ExitActivate(){
  exit(0);
}
