#include "undertool.h"
#include <sstream>

UnderTool::UnderTool(){
  set_toolbar_style(Gtk::TOOLBAR_ICONS);

  nextButton.set_stock_id(Gtk::Stock::GO_FORWARD);
  prevButton.set_stock_id(Gtk::Stock::GO_BACK);
  fitButton.set_stock_id(Gtk::Stock::ZOOM_FIT);
  
  prepend(prevButton,sigc::mem_fun(*this,&UnderTool::PrevButtonClicked));
  append(fitButton,sigc::mem_fun(*this,&UnderTool::FitButtonClicked));
  append(nextButton,sigc::mem_fun(*this,&UnderTool::NextButtonClicked));
  append(nameLabel);
  prevButton.show();
  fitButton.show();
  nextButton.show();
  nameLabel.show();
}

UnderTool::~UnderTool(){
  
}

void UnderTool::Create(DrawArea *drawArea0){
  drawArea=drawArea0;

  drawArea->SignalImageChange().connect
    (sigc::mem_fun(*this,&UnderTool::ImageChange));

  //  fileList=fileList0;
  /*
  std::string text;
  text="./sssaa.sfd.png";
  std::cout<<text<<">>"<<fileList->GetLastString(text,".")<<std::endl;
  */
}

void UnderTool::NextButtonClicked(){
  std::cout<<"NEXT"<<std::endl;
  drawArea->NextImage();
}

void UnderTool::PrevButtonClicked(){
  std::cout<<"PREV"<<std::endl;
  drawArea->PrevImage();
}

void UnderTool::FitButtonClicked(){
  std::cout<<"FIT"<<std::endl;
  drawArea->FitImage();
}

void UnderTool::ImageChange(FileItem *file0,double width,double height){
  std::stringstream byteName0,sizeName0;
  std::string str0;
  int byteG,byteM,byteK,byteB;

  if(file0){
    byteG=file0->size/1000000000;
    byteM=file0->size%1000000000;
    byteM=byteM/1000000;
    byteK=file0->size%1000000;
    byteK=byteK/1000;
    byteB=file0->size%1000;
    
    if(byteG>0){
      byteName0<<byteG<<"."<<byteM/100<<"GB";
    }
    else if(byteM>0){
      byteName0<<byteM<<"."<<byteK/100<<"MB";
    }
    else if(byteK>0){
      byteName0<<byteK<<"."<<byteB/100<<"KB";
    }
    else{
      byteName0<<byteB<<"B";
    }
    
    sizeName0<<(int)width<<"x"<<(int)height;
    
    std::cout<<"TARGET:"<<" "
	     <<"NAME="<<file0->name<<" "
	     <<"TYPE="<<file0->type<<" "
	     <<"SIZE="<<file0->size<<std::endl;
    str0=file0->name+" "+byteName0.str()+" "+sizeName0.str();
  }
  else{
    str0="NO IMAGE";
  }
  nameLabel.remove();
  nameLabel.add_label(str0);
}
