#include "window.h"

MainWindow::MainWindow(){
  imagePX=0;
  imagePY=0;
  imageRotate=0;
  imageSize=0;

  //  add_events(Gdk::FOCUS_CHANGE_MASK);

  /*
  fileList.ReadFolder("/home/yf/xpm/pngwiki.png");
  fileList.View();
  */

  set_title("THE SPINING PNG");

  labelRotate= new Gtk::Label("Rotate:");
  labelRotate->show();
  labelSize= new Gtk::Label("Size:");
  labelSize->show();

  adjRotate= new Gtk::Adjustment(imageRotate,-1,361,1,20,0);
  adjSize= new Gtk::Adjustment(imageSize,-100,100,0.01,1,0);

  spinRotate= new Gtk::SpinButton(*adjRotate,10,0);
  spinRotate->show();

  spinSize= new Gtk::SpinButton(*adjSize,0.1,2);
  spinSize->show();
  
  mTable= new Gtk::Table(5,4,false);

  mTable->attach(spinMenu,0,5,0,1,
		 Gtk::FILL|Gtk::EXPAND,Gtk::FILL,0,0);
  mTable->attach(toolSep,0,1,1,2,
		 Gtk::FILL|Gtk::EXPAND,Gtk::FILL,0,0);
  mTable->attach(*labelRotate,1,2,1,2,
		 Gtk::FILL,Gtk::FILL,0,0);
  mTable->attach(*spinRotate,2,3,1,2,
		 Gtk::FILL,Gtk::FILL,0,0);
  mTable->attach(*labelSize,3,4,1,2,
		 Gtk::FILL,Gtk::FILL,0,0);
  mTable->attach(*spinSize,4,5,1,2,
		 Gtk::FILL,Gtk::FILL,0,0);
  mTable->attach(drawArea,0,5,2,3);
  mTable->attach(underTool,0,5,3,4,
		 Gtk::FILL|Gtk::EXPAND,Gtk::FILL,0,0);
  toolSep.show();
  mTable->show();

  add(*mTable);
}

MainWindow::~MainWindow(){
  delete spinRotate;
  delete spinSize;
  delete adjRotate;
  delete adjSize;
  delete labelRotate;
  delete labelSize;
  delete mTable;
}

void MainWindow::Create(std::string filename0){
  std::cout<<"WINDOW CREATE"<<std::endl;
  /*
  fileList.ReadFolder(filename0);
  fileList.View();
  */

  underTool.Create(&drawArea);
  drawArea.Create(this,filename0,
		  &imagePX,&imagePY,
		  &imageRotate,&imageSize);

  spinMenu.Create(&drawArea);

  drawArea.show();
  spinMenu.show();
  underTool.show();

  spinRotate->signal_value_changed().connect
    (sigc::mem_fun(*this,&MainWindow::RotateValueChanged));

  spinSize->signal_value_changed().connect
    (sigc::mem_fun(*this,&MainWindow::SizeValueChanged));  

  drawArea.SignalRotateChange().connect
    (sigc::mem_fun(*this,&MainWindow::RotateChange));
  drawArea.SignalSizeChange().connect
    (sigc::mem_fun(*this,&MainWindow::SizeChange));
  
  drawArea.SignalFullChange().connect
    (sigc::mem_fun(*this,&MainWindow::FullChange));

}

int MainWindow::RotateInPut(double *value){
  std::cout<<" ROTATE InPUT:"<<*value<<std::endl;
}
void MainWindow::RotateValueChanged(){
  int value0;
  
  value0=spinRotate->get_value();

  if(value0<0){
    value0=360+value0;
  }
  else if(value0>360){
    value0=value0-360;
  }

  spinRotate->set_value(value0);

  imageRotate=value0*M_PI/180;

  Gdk::Rectangle rect(0,0,drawArea.get_width(),drawArea.get_height());
  if(drawArea.get_window())
    (drawArea.get_window())->invalidate_rect(rect,false);
}

void MainWindow::SizeValueChanged(){
  imageSize=spinSize->get_value();
  
  Gdk::Rectangle rect(0,0,drawArea.get_width(),drawArea.get_height());
  if(drawArea.get_window())
    (drawArea.get_window())->invalidate_rect(rect,false);
  
}

void MainWindow::RotateChange(double value){
  
  //std::cout<<" ROTATE VALUE="<<value<<std::endl;
  
  spinRotate->set_value(value*180/M_PI);
  
}

void MainWindow::SizeChange(double value){
  
  // std::cout<<"SIZE VALUE="<<value<<std::endl;
  spinSize->set_value(value);
  
}

void MainWindow::FullChange(bool value){
  if(value){
    HideExceptDrawArea();
    fullscreen();
    (drawArea.get_window())->fullscreen();
    drawArea.add_modal_grab();
  }
  else{
    drawArea.remove_modal_grab();
    (drawArea.get_window())->unfullscreen();
    unfullscreen();
    ShowALL();
  }
}

void MainWindow::HideExceptDrawArea(){
  toolSep.hide();
  labelRotate->hide();
  labelSize->hide();
  spinRotate->hide();
  spinSize->hide();
  spinMenu.hide();
  underTool.hide();  
}
void MainWindow::ShowALL(){
  toolSep.show();
  labelRotate->show();
  labelSize->show();
  spinRotate->show();
  spinSize->show();
  spinMenu.show();
  underTool.show();
}
/*
bool MainWindow::on_key_press_event(GdkEventKey *event){
  std::cout<<"KEY PRESS:"<<" "
	   <<"TYPE="<<event->type<<" "
	   <<"STATE="<<event->state<<" "
	   <<"VALUE="<<event->keyval<<" "
	   <<"STRING="<<event->string<<" "
	   <<"KEYCODE="<<event->hardware_keycode<<" "
	   <<std::endl;
}

bool MainWindow::on_key_release_event(GdkEventKey *event){
  std::cout<<"KEY RELEASE:"<<" "
	   <<"TYPE="<<event->type<<" "
	   <<"STATE="<<event->state<<" "
	   <<"VALUE="<<event->keyval<<" "
	   <<"STRING="<<event->string<<" "
	   <<"KEYCODE="<<event->hardware_keycode<<" "
	   <<std::endl;
}

*/
