#ifndef SPIN_WINDOW_H_
#define SPIN_WINDOW_H_

#include <gtkmm.h>
#include <cmath>
#include "drawarea.h"
#include "menubar.h"
#include "undertool.h"
#include "understatus.h"

class MainWindow : public Gtk::Window{
 private:
  double imagePX;
  double imagePY;
  double imageRotate;
  double imageSize;
  Gtk::HSeparator toolSep;
  Gtk::Adjustment *adjRotate;
  Gtk::Adjustment *adjSize;
  Gtk::Label *labelRotate;
  Gtk::Label *labelSize;
  Gtk::SpinButton *spinRotate;
  Gtk::SpinButton *spinSize;
  Gtk::Table *mTable;
  Gtk::FileChooserWidget *fileChooser;
  Gtk::FileFilter *fileFilter;
  DrawArea drawArea;
  SpinMenu spinMenu;
  UnderTool underTool;
 public:
  MainWindow();
  ~MainWindow();
  void Create(std::string filename0);
  void HideExceptDrawArea();
  void ShowALL();
 protected:
  int RotateInPut(double *value);
  void RotateValueChanged();
  void SizeValueChanged();
  void RotateChange(double value);
  void SizeChange(double value);
  void FullChange(bool value);
  /*
  virtual bool on_key_press_event(GdkEventKey *event);
  virtual bool on_key_release_event(GdkEventKey *event);
  */
};

#endif
